﻿using System.Collections.Generic;
using DataGrid = Microsoft.Windows.Controls.DataGrid;

namespace WDCF
{
    /// <summary>
    /// Base class for all <see cref="DataGrid"/> related formatting classes.
    /// </summary>
    public abstract class DataGridConditionalFormatter : ConditionalFormatter<DataGrid>
    {
        
        /// <summary>
        /// Initializes a new instance of the <see cref="DataGridConditionalFormatter"/> class.
        /// </summary>
        /// <param name="dataGrid"></param>
        /// <param name="conditions"></param>
        protected DataGridConditionalFormatter(
            DataGrid dataGrid,
            IList<Condition> conditions)
            :base(dataGrid, conditions)
        {
            this.Grid = dataGrid;
        }

        /// <summary>
        /// Gets or sets the associated <see cref="DataGrid"/>.
        /// </summary>
        protected DataGrid Grid { get; private set; }
        
    }
}
