﻿using System.Collections.Generic;
using System.Windows.Controls;

namespace WDCF
{
    /// <summary>
    /// Base class for all <see cref="ListView"/> related formatting classes.
    /// </summary>
    public abstract class ListViewConditionalFormatter : ConditionalFormatter<ListView>
    {
        /// <summary>
        /// Creates a new instance of the <see cref="ListViewConditionalFormatter"/> class.
        /// </summary>
        /// <param name="listView"></param>
        /// <param name="conditions"></param>
        protected ListViewConditionalFormatter(ListView listView, IList<Condition> conditions) 
            : base(listView, conditions)
        {
            this.ListView = listView;
        }

        /// <summary>
        /// Gets or sets the associated <see cref="ListView"/>.
        /// </summary>
        protected ListView ListView { get; private set; }
    }
}
